//---------------------------------------------------
// 
//---------------------------------------------------

#include "cInput.h"

CInput::CInput()
{
	for( int i=0 ; i<INPUT_MAX ; i++ )
	{
		keyDataBefore[i] = keyDataNow[i] = false ;
		padDataBefore[0][i] = padDataNow[0][i] = false ;
		padDataBefore[1][i] = padDataNow[1][i] = false ;
	}
}

CInput::~CInput()
{
	fInput.uninit();
}

/*
 ̃NXg߂̏
 */
void CInput::init( Fl_Window *lw , fk_Window *kw )
{
	// fkut_Inputg
	if( fInput.init( fl_display , fl_xid( lw ) ) == S_OK )
	{
		isInit = true ;
	}
	else
	{
		isInit = false ;
		fl_alert( "fkut_Input init error." );
	}

	window = kw ;
	inputCodeInit();
	update();
	update();
}

/*
 R[hftHgɐݒ
 */
void CInput::inputCodeInit()
{
	keyCode[INPUT_1]	  = 'z' ;
	keyCode[INPUT_2]	  = 'x' ;
	keyCode[INPUT_3]	  = 'c' ;
	keyCode[INPUT_4]	  = 'v' ;
	keyCode[INPUT_5]	  = ' ' ;
	keyCode[INPUT_START]  = 'p' ;
	keyCode[INPUT_SELECT] = 's' ;
	for( int i=0 ; i<2 ; i++ )
	{
		padCode[i][INPUT_1]		 = 0 ;
		padCode[i][INPUT_2]		 = 1 ;
		padCode[i][INPUT_3]		 = 2 ;
		padCode[i][INPUT_4]		 = 3 ;
		padCode[i][INPUT_5]		 = 4 ;
		padCode[i][INPUT_START]	 = 5 ;
		padCode[i][INPUT_SELECT] = 6 ;
	}
}

/*
 R[h̐ݒ
 */
void CInput::config()
{
}

/*
 ͎tƃf[^XV
 */
void CInput::update()
{
	// ݂̃f[^ߋ̃f[^ɓ]
	for( int i=0 ; i<INPUT_MAX ; i++ )
	{
		keyDataBefore[i] = keyDataNow[i] ;
		padDataBefore[0][i] = padDataNow[0][i] ;
		padDataBefore[1][i] = padDataNow[1][i] ;
	}

	// L[{[h̓͏XV
	for( int i=0 ; i<7 ; i++ )
	{
		keyDataNow[i] = window->getKeyStatus( keyCode[i] );
	}
	keyDataNow[7]  = window->getSpecialKeyStatus( FK_UP );
	keyDataNow[8]  = window->getSpecialKeyStatus( FK_RIGHT );
	keyDataNow[9]  = window->getSpecialKeyStatus( FK_DOWN );
	keyDataNow[10] = window->getSpecialKeyStatus( FK_LEFT );

	// pbh̓͏XV
	if( isInit )
	{
		fInput.update();
		padInputData[0] = fInput.getInputStatus( 1 );
		padInputData[1] = fInput.getInputStatus( 2 );
		for( int i=0 ; i<2 ; i++ )
		{
			for( int j=0 ; j<7 ; j++ )
			{
				if( padCode[i][j] < 32 )
				{
					padDataNow[i][j] = padInputData[i].button[padCode[i][j]] ;
				}
			}
			padDataNow[i][7]  = padInputData[i].up ;
			padDataNow[i][8]  = padInputData[i].right ;
			padDataNow[i][9]  = padInputData[i].down ;
			padDataNow[i][10] = padInputData[i].left ;
		}
	}
}

/*
 ͔iꂽj
 */
bool CInput::checkDown( int key , int dev )
{
	if( dev%2 == 1 &&  padDataNow[0][key] && !padDataBefore[0][key] )
	{
		return true ;
	}
	if( dev%4 >= 2 &&  padDataNow[1][key] && !padDataBefore[1][key] )
	{
		return true ;
	}
	return ( dev%8 >= 4 &&  keyDataNow[key] && !keyDataBefore[key] ) ;
}

/*
 ͔iꂽj
 */
bool CInput::checkUp( int key , int dev )
{
	if( dev%2 == 1 && !padDataNow[0][key] &&  padDataBefore[0][key] )
	{
		return true ;
	}
	if( dev%4 >= 2 && !padDataNow[1][key] &&  padDataBefore[1][key] )
	{
		return true ;
	}
	return ( dev%8 >= 4 && !keyDataNow[key] &&  keyDataBefore[key] ) ;
}

/*
 ͔iĂŒj
 */
bool CInput::checkPress( int key , int dev )
{
	if( dev%2 == 1 &&  padDataNow[0][key] )
	{
		return true ;
	}
	if( dev%4 >= 2 &&  padDataNow[1][key] )
	{
		return true ;
	}
	return ( dev%8 >= 4 && keyDataNow[key] ) ;
}
