//---------------------------------------------------
// 
//---------------------------------------------------

#pragma once

#include "common.h"
#include "../FKUT/Input.h"
#include <Fl/x.h>

enum inputButtonType
{
	INPUT_1 ,
	INPUT_2 ,
	INPUT_3 ,
	INPUT_4 ,
	INPUT_5 ,
	INPUT_START ,
	INPUT_SELECT ,
	INPUT_UP ,
	INPUT_RIGHT ,
	INPUT_DOWN ,
	INPUT_LEFT ,
	INPUT_MAX ,
};

enum device
{
	PAD1 = 1 ,
	PAD2 = 2 ,
	KEY  = 4 ,
};

class CInput
{
private:
	fk_Window		*window ;
	fkut_Input		fInput ;
	fkut_InputInfo	padInputData[2] ;
	bool			isInit ;

	char	keyCode[7] ;
	bool	keyDataBefore[INPUT_MAX] ;
	bool	keyDataNow[INPUT_MAX] ;
	int		padCode[2][7] ;
	bool	padDataBefore[2][INPUT_MAX] ;
	bool	padDataNow[2][INPUT_MAX] ;

public:
	CInput();
	~CInput();

	void	init( Fl_Window *lw , fk_Window *kw );
	void	inputCodeInit();
	void	config();
	void	update();

	bool	checkDown( int key , int dev = KEY );
	bool	checkUp( int key , int dev = KEY );
	bool	checkPress( int key , int dev = KEY );

};
