//-------------------------------------------
// Q[{
//-------------------------------------------

#include "gameMain.h"
#include "title.h"
#include "option.h"

CGameMain::CGameMain()
{
	gameScene = NULL ;
	sceneType = S_TITLE ;
	sceneChange = false ;
}

CGameMain::~CGameMain()
{
}

/*
 
 */
void CGameMain::init( Fl_Window *lw , fk_Window *kw )
{
	mainWindow = lw ;
	window = kw ;
	mainWindow->show();
	window->show();
	window->setScene( &scene );
	scene.entryCamera( &camera );
	camera.glMoveTo(0.0, 100.0, 100.0);
	camera.glFocus(0.0, 0.0, 0.0);
	camera.glUpvec(0.0, 1.0, 0.0);
	lightModel.setShape(&light);
	lightModel.setMaterial(White);
	lightModel.getMaterial()->setAmbDiff(1.0, 1.0, 1.0);
	lightModel.glMoveTo(0.0, 0.0, 0.0);
	lightModel.glFocus(0.5, -1.0, 0.0);
	scene.entryModel( &lightModel );
	database.configDB.read( "config.ini" );
	input.init( mainWindow , window );
	//input.inputCodeInit();
	changeScene();
}

/*
 VV[̍쐬
 */
void CGameMain::changeScene()
{
	deleteScene();
	switch( sceneType )
	{
	case S_TITLE:
		gameScene = new CTitle();
		break ;
	case S_OPTION:
		gameScene = new COption();
		break ;
	default:
		fl_alert( "Not defined sceneType." );
		gameScene = new CTitle();
	}
	gameScene->setAddress( &sceneType , &database , &input );
	gameScene->init();
}

/*
 V[̍폜
 */
void CGameMain::deleteScene()
{
	if( gameScene != NULL )
	{
		delete gameScene ;
		gameScene = NULL ;
	}
}

/*
 Q[̒
 */
void CGameMain::game()
{
	database.soundDB.loadBGM( "test" , "test.ogg" );
	database.graphDB.setAddress( window , &scene );
	database.graphDB.setImage( "test" , "test.png" );
	while( 1 )
	{
		if( !mainWindow->visible() )
		{
			if( !Fl::wait() )
			{
				break ;
			}
			else
			{
				continue ;
			}
		}
		if( !Fl::check() )
		{
			break ;
		}
		if( !window->winOpenStatus() )
		{
			continue ;
		}

		input.update();
		sceneChange = gameScene->onPeriod();
		if( sceneType == S_END )
		{
			break ;
		}
		if( sceneChange )
		{
			changeScene();
		}

		if( input.checkUp( INPUT_2 ) )
		{
			database.soundDB.stopBGM( "test" );	// AŌĂԁ[voO
		}
		else
		{
			database.soundDB.playBGM( "test" );
		}
		database.graphDB.a();
		//database.soundDB.playBGM( "test2" );
	}
	deleteScene();
	database.soundDB.deleteAll();
	database.configDB.write( "config.ini" );
	database.graphDB.deleteImageAll();
}
